/* Copyright (c) 2000-2006 Wolfgang Hoermann and Josef Leydold */
/* Department of Statistics and Mathematics, WU Wien, Austria  */

#include <unur_source.h>
#include <urng/urng.h>
#include "urng_default_source.h"
#include "urng_builtin.h"
#include "urng_fvoid.h"
#include "urng_gsl.h"
#include "urng_gslqrng.h"
#include "urng_prng.h"
#include "urng_randomshift.h"
#include "urng_rngstreams.h"
static UNUR_URNG *urng_default = NULL;
static UNUR_URNG *urng_aux_default = NULL;
UNUR_URNG *
unur_get_default_urng( void )
{
  if( urng_default == NULL ) {
    urng_default = UNUR_URNG_DEFAULT;
    if( urng_default == NULL ) {
      _unur_error("URNG",UNUR_ERR_NULL,"Cannot set default URNG. EXIT !!!");
      exit(EXIT_FAILURE);
    }
  }
  return (urng_default);
} 
UNUR_URNG *
unur_set_default_urng( UNUR_URNG *urng_new )
{
  UNUR_URNG *urng_old = urng_default;
  _unur_check_NULL("URNG", urng_new, urng_default);
  urng_default = urng_new;     
  return (urng_old);
} 
UNUR_URNG *
unur_get_default_urng_aux( void )
{
  if( urng_aux_default == NULL ) {
    urng_aux_default = UNUR_URNG_AUX_DEFAULT;
    if( urng_aux_default == NULL ) {
      _unur_error("URNG",UNUR_ERR_NULL,"Cannot set default auxilliary URNG. EXIT !!!");
      exit(EXIT_FAILURE);
    }
  }
  return (urng_aux_default);
} 
UNUR_URNG *
unur_set_default_urng_aux( UNUR_URNG *urng_aux_new )
{
  UNUR_URNG *urng_aux_old = urng_aux_default;
  _unur_check_NULL("URNG", urng_aux_new, urng_aux_default);
  urng_aux_default = urng_aux_new;     
  return (urng_aux_old);
} 
