/* Copyright (c) 2000-2006 Wolfgang Hoermann and Josef Leydold */
/* Department of Statistics and Mathematics, WU Wien, Austria  */

#include <unur_source.h>
int
_unur_isfinite (const double x)
{
#if HAVE_DECL_ISFINITE
  return (isfinite(x) ? TRUE : FALSE);
#elif defined(_MSC_VER) 
  return (_finite(x) ? TRUE : FALSE);
#elif HAVE_IEEE_COMPARISONS
  if (x < INFINITY && x > -INFINITY)
    return TRUE;
  else
    return FALSE;
#else
# error
# error +--------------------------------------------------+
# error ! Sorry, Cannot handle INFINITY correctly! ....... !
# error ! Please contact <unuran@statistik.wu-wien.ac.at>. !
# error +--------------------------------------------------+
# error
#endif
} 
int
_unur_isnan (const double x)
{
#if HAVE_DECL_ISNAN
  return (isnan(x) ? TRUE : FALSE);
#elif defined(_MSC_VER) 
  return (_isnan(x) ? TRUE : FALSE);
#elif HAVE_IEEE_COMPARISONS
  return ((x!=x) ? TRUE : FALSE);
#else
# error
# error +--------------------------------------------------+
# error ! Sorry, Cannot handle NaN correctly! ............ !
# error ! Please contact <unuran@statistik.wu-wien.ac.at>. !
# error +--------------------------------------------------+
# error
#endif
} 
int
_unur_isinf (const double x)
{
#if HAVE_DECL_ISINF
  return isinf(x);
#elif defined(_MSC_VER) 
  int fpc = _fpclass(x);
  if (fpc == _FPCLASS_PINF)
    return +1;
  else if (fpc == _FPCLASS_NINF)
    return -1;
  else 
    return 0;
#elif HAVE_IEEE_COMPARISONS
  if (x>=INFINITY)
    return 1;
  else if (x<=-INFINITY)
    return -1;
  else
    return 0;
#else
# error
# error +--------------------------------------------------+
# error ! Sorry, Cannot handle INFINITY correctly! ....... !
# error ! Please contact <unuran@statistik.wu-wien.ac.at>. !
# error +--------------------------------------------------+
# error
#endif
} 
